package com.ruoyi.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.ruoyi.pay.domain.bo.PaySubInfoBo;
import com.ruoyi.pay.domain.vo.PaySubInfoVo;
import com.ruoyi.pay.domain.PaySubInfo;
import com.ruoyi.pay.mapper.PaySubInfoMapper;
import com.ruoyi.pay.service.IPaySubInfoService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 租户订阅信息Service业务层处理
 *
 * @author ruoyi
 * @date 2025-05-13
 */
@RequiredArgsConstructor
@Service
public class PaySubInfoServiceImpl implements IPaySubInfoService {

    private final PaySubInfoMapper baseMapper;

    /**
     * 查询租户订阅信息
     */
    @Override
    public PaySubInfoVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询租户订阅信息列表
     */
    @Override
    public TableDataInfo<PaySubInfoVo> queryPageList(PaySubInfoBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<PaySubInfo> lqw = buildQueryWrapper(bo);
        Page<PaySubInfoVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询租户订阅信息列表
     */
    @Override
    public List<PaySubInfoVo> queryList(PaySubInfoBo bo) {
        LambdaQueryWrapper<PaySubInfo> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<PaySubInfo> buildQueryWrapper(PaySubInfoBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<PaySubInfo> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getTenantId() != null, PaySubInfo::getTenantId, bo.getTenantId());
        lqw.like(StringUtils.isNotBlank(bo.getCompanyName()), PaySubInfo::getCompanyName, bo.getCompanyName());
        lqw.eq(bo.getStartTime() != null, PaySubInfo::getStartTime, bo.getStartTime());
        lqw.eq(bo.getEndTime() != null, PaySubInfo::getEndTime, bo.getEndTime());
        lqw.eq(StringUtils.isNotBlank(bo.getActive()), PaySubInfo::getActive, bo.getActive());
        lqw.eq(bo.getSubplanId() != null, PaySubInfo::getSubplanId, bo.getSubplanId());
        lqw.like(StringUtils.isNotBlank(bo.getSubplanName()), PaySubInfo::getSubplanName, bo.getSubplanName());
        return lqw;
    }

    /**
     * 新增租户订阅信息
     */
    @Override
    public Boolean insertByBo(PaySubInfoBo bo) {
        PaySubInfo add = BeanUtil.toBean(bo, PaySubInfo.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改租户订阅信息
     */
    @Override
    public Boolean updateByBo(PaySubInfoBo bo) {
        PaySubInfo update = BeanUtil.toBean(bo, PaySubInfo.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(PaySubInfo entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除租户订阅信息
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
